﻿// TRANSLATED FROM PAPER.JS examples/Animated/RoundedRectangles.html
package
{
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.geom.Point;
	public class Rounder extends Sprite
	{
		private var colors:Array = new Array(0xff1493,0xffffff,0x00fa9a,0xffffff);
		private var angle:uint = 2;
		public function Rounder()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);	
		}
		private function addedHandler(e:Event):void
		{
			for(var i:Number = 2;i<20;i++){
				var rect:Shape = new Shape();
				rect.graphics.beginFill(colors[i%4]);
				rect.graphics.drawRoundRect(-6,-6,12,12,2,2);
				rect.graphics.endFill();
				rect.scaleX = rect.scaleY = (1-i/25)*10;
				addChild(rect);
			}
			
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			var i:uint = 0;
			while(i<numChildren)
			{
				var rect:Shape = getChildAt(i) as Shape;
				var distPoint:Point = new Point((rect.x-mouseX)/(i + 0),(rect.y-mouseY)/(i + 0));
				var distance:Number = Math.sqrt(distPoint.x*distPoint.x + distPoint.y*distPoint.y);
				rect.rotation = Math.sin((angle+i)/10)*100;
				if(distance>10){
					rect.x-=distPoint.x;
					rect.y-=distPoint.y;
				}
				i++;
			}
			angle++;
		}
	}
}